import { CssValue } from '@platform/css';
import * as React from 'react';
import { Subject } from 'rxjs';
import { t } from '../../common';
export declare type FormulaInputMode = 'spreadsheet';
export declare type IFormulaInputProps = {
    value?: string;
    mode?: FormulaInputMode;
    fontSize?: number;
    multiline?: boolean;
    allowTab?: boolean;
    focusOnLoad?: boolean;
    selectOnLoad?: boolean;
    maxLength?: number;
    height?: number;
    events$?: Subject<t.FormulaInputEvent>;
    style?: CssValue;
};
export declare type IFormulaInputState = {
    isLoaded?: boolean;
};
export declare class FormulaInput extends React.PureComponent<IFormulaInputProps, IFormulaInputState> {
    state: IFormulaInputState;
    private unmounted$;
    private state$;
    private editor;
    private editorRef;
    private readonly _events$;
    readonly events$: import("rxjs").Observable<t.FormulaInputEvent>;
    private readonly execCommand$;
    private readonly modifierKeys;
    componentDidMount(): void;
    private init;
    componentWillUnmount(): void;
    get isFocused(): boolean;
    private get height();
    private get className();
    private get fontSize();
    redraw(): this;
    focus(): this;
    selectAll(): this;
    cursorToStart(): this;
    cursorToEnd(): this;
    private setGlobalStyles;
    render(): JSX.Element;
    private fire;
    private focusHandler;
    private handleBeforeChange;
}
